package com.light.prank.sound.app.allui.custom;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.SystemClock;
import android.view.View;

import androidx.appcompat.app.AppCompatActivity;

import com.light.prank.sound.app.utils.MyUtils;
import com.light.prank.sound.app.utils.MyRecorderUtils;
import com.prank.tool.sounds.app.R;
import com.prank.tool.sounds.app.databinding.AcRecordingBinding;

public class AcRecording extends AppCompatActivity {
  private AcRecordingBinding binding;
    private long startTime;
    private long elapsedTime;
    private Handler handler = new Handler();
    private Runnable runnable;
    private boolean isCreate = false;

    private MyRecorderUtils myRecorderUtils;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = AcRecordingBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        MyUtils.setStatusBarTextColor(this, true);
        myRecorderUtils = new MyRecorderUtils(this);

        binding.audioTime.setText(R.string.time_init);

        initEvent();
    }

    private void initEvent() {
        binding.back.setOnClickListener(v -> finish());
        binding.imMic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                binding.imMic.setSelected(!binding.imMic.isSelected());
                createSound();
            }
        });
    }

    private void createSound() {
        if (!isCreate) {
            myRecorderUtils.startRecording();
            isCreate = true;
            runnable = new Runnable() {
                @SuppressLint("DefaultLocale")
                @Override
                public void run() {
                    long currentTime = SystemClock.elapsedRealtime();
                    elapsedTime = currentTime - startTime;
                    int milliseconds = (int) (elapsedTime % 1000) / 10;
                    int seconds = (int) (elapsedTime / 1000) % 60;
                    int minutes = (int) (elapsedTime / (1000 * 60)) % 60;
                    binding.audioTime.setText(String.format("%02d : %02d : %02d", minutes, seconds, milliseconds));
                    handler.postDelayed(this, 10);
                }
            };
            startTime = SystemClock.elapsedRealtime();
            handler.post(runnable);
        } else {
            myRecorderUtils.stopRecording();

            handler.removeCallbacks(runnable);
            Intent intent = new Intent(AcRecording.this, AcSave.class);
            intent.putExtra(AcSave.KEY_Time, elapsedTime);
            intent.putExtra(AcSave.KEY_Path, myRecorderUtils.getTempFileName());
            intent.putExtra(AcSave.KEY_import, 1);
            startActivity(intent);
            finish();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        handler.removeCallbacks(runnable);
    }
}